<?php


namespace FiloBlu\Refilo\Model\Indexer\Processor\Type;

use Magento\Catalog\Model\Product\Attribute\Source\Status;
use Magento\Catalog\Model\ProductRepository;
use Magento\Framework\Api\FilterBuilder;
use Magento\Framework\Api\Search\FilterGroup;
use Magento\Framework\Api\SearchCriteriaInterface;
use Magento\Framework\Api\SearchCriteriaBuilder;

class Grouped extends Simple
{
    /**
     * @var ProductRepository
     */
    private $productRepository;
    /**
     * @var FilterGroup
     */
    private $filterGroup;
    /**
     * @var FilterBuilder
     */
    private $filterBuilder;
    /**
     * @var Status
     */
    private $productStatus;
    /**
     * @var Simple
     */
    private $_simple_product;

    /**
     * @var array
     */
    private $child_products;
    /**
     * @var SearchCriteriaInterface
     */
    private $criteria;
    /**
     * @var SearchCriteriaBuilder
     */
    private $searchCriteriaBuilder;

    /**
     * @var array
     */
    private $bundle_options;


    /**
     * Configurable constructor.
     * @param ProductRepository $productRepository
     * @param FilterGroup $filterGroup
     * @param FilterBuilder $filterBuilder
     * @param Status $productStatus
     * @param Simple $simple_product
     * @param SearchCriteriaInterface $criteria
     * @param SearchCriteriaBuilder $searchCriteriaBuilder
     */
    public function __construct(
        ProductRepository $productRepository,
        FilterGroup $filterGroup,
        FilterBuilder $filterBuilder,
        Status $productStatus,
        Simple $simple_product,
        SearchCriteriaInterface $criteria,
        SearchCriteriaBuilder $searchCriteriaBuilder
    )
    {

        $this->productRepository = $productRepository;
        $this->filterGroup = $filterGroup;
        $this->filterBuilder = $filterBuilder;
        $this->productStatus = $productStatus;
        $this->_simple_product = $simple_product;
        $this->criteria = $criteria;
        $this->searchCriteriaBuilder = $searchCriteriaBuilder;
    }

    public function process()
    {
        parent::process();
        $this->getChilds();
        return $this->_item;

    }

    /**
     * @return array
     */
    protected function getChilds() {

        $links = $this->_product->getTypeInstance()->getChildrenIds($this->_product->getId());
        $this->_item->childs = [];

        if (count($links)) {
            $this->_item->childs = array_values(array_shift($links));

        }

    }

}
